
// ByteArrayJFO.java
// Andrew Davison, July 2007, ad@fivedots.coe.psu.ac.th

/* A java file object which accepts byte codes on its input stream, and sends them
   to its output stream. It also allows the output stream to be accessed 
   as a byte array.
*/


import java.io.*;
import java.net.URI;
import javax.tools.*;


public class ByteArrayJFO extends SimpleJavaFileObject
{
  private ByteArrayOutputStream baos = null;


  public ByteArrayJFO(String className, Kind kind) throws Exception
  {  super( new URI(className), kind);  }


  public InputStream openInputStream() throws IOException
  // the input stream to the java file object accepts bytes
  { return new ByteArrayInputStream(baos.toByteArray()); }


  public OutputStream openOutputStream() throws IOException
  // the output stream supplies bytes
  {  return baos = new ByteArrayOutputStream();  }


  public byte[] getByteArray()
  // access the byte output stream as an array
  {  return baos.toByteArray(); }

} // end of ByteArrayJFO class
