
// StringJFO.java
// Andrew Davison, July 2007, ad@fivedots.coe.psu.ac.th

/* A java file object which represents source code in a string.
   Similar to an example in the JavaCompiler API docs.
*/

import java.io.*;
import java.net.URI;
import javax.tools.*;


public class StringJFO extends SimpleJavaFileObject
{
  private String codeStr = null;


  public StringJFO(String uri, String codeStr) throws Exception
  {
    super(new URI(uri), Kind.SOURCE);    // store source code
    this.codeStr = codeStr;
  }


  public CharSequence getCharContent(boolean errs) throws IOException
  // called by the Java compiler internally to get the source code
  { return codeStr; }

} // end of StringJFO class
